package jdk.management.resource.internal.inst;

import jdk.internal.instrumentation.InstrumentationMethod;
import java.io.IOException;
import jdk.management.resource.internal.ApproverGroup;
import jdk.management.resource.internal.ResourceIdImpl;
import java.io.FileDescriptor;
import jdk.internal.instrumentation.InstrumentationTarget;
import jdk.Exported;

@Exported(false)
@InstrumentationTarget("sun.nio.ch.SocketDispatcher")
public class SocketDispatcherRMHooks
{
    public SocketDispatcherRMHooks() {
    }
    
    @InstrumentationMethod
    void close(FileDescriptor fileDescriptor) throws IOException {
        long n = 0L;
        ResourceIdImpl of = ResourceIdImpl.of(fileDescriptor);
        try {
            this.close(fileDescriptor);
            n = 1L;
        }
        finally {
            ApproverGroup.FILEDESCRIPTOR_OPEN_GROUP.getApprover(fileDescriptor).request(-n, of);
        }
    }
}
